<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: arm_compute/core/CL/kernels/CLConvolutionKernel.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_c_l_convolution_kernel_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">CLConvolutionKernel.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_c_l_convolution_kernel_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __ARM_COMPUTE_CLCONVOLUTIONKERNEL_H__</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __ARM_COMPUTE_CLCONVOLUTIONKERNEL_H__</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_c_l_simple2_d_kernel_8h.xhtml">arm_compute/core/CL/ICLSimple2DKernel.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacearm__compute.xhtml">arm_compute</a></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;{</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">class </span><a class="code" href="namespacearm__compute.xhtml#af87af588094f04e537df98eaf0426cb6">ICLTensor</a>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment">/****************************************************************************************\</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> *                                    Square Convolution                                *</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment">\****************************************************************************************/</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matrix_size&gt;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">   52</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolutionKernel</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml">ICLSimple2DKernel</a></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;{</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a07e35fa34ecbbc82d848fa3997cc6fdb">configure</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *input, <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *output, <span class="keyword">const</span> int16_t *conv, uint32_t scale, <span class="keywordtype">bool</span> border_undefined);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a423f9a45a52983b4de5e2b347f4369c7">border_size</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;};</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a4751499f1c526c7285e7e946c2e84541">   70</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolution3x3Kernel</a> = <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolutionKernel&lt;3&gt;</a>;</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ac4cfbdf439d7bf5d420546298bd5ca0d">   72</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolution5x5Kernel</a> = <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolutionKernel&lt;5&gt;</a>;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a99a54c937a254c96cd1a29a96ffa7dcf">   74</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolution7x7Kernel</a> = <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolutionKernel&lt;7&gt;</a>;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a908439cd5cf8253865d5c70a413fd607">   76</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolution9x9Kernel</a> = <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">CLConvolutionKernel&lt;9&gt;</a>;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">/****************************************************************************************\</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment"> *                              Separable Square Convolution                            *</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">\****************************************************************************************/</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matrix_size&gt;</div><div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">   84</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolutionHorKernel</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml">ICLSimple2DKernel</a></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;{</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolutionHorKernel</a>();</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a07e35fa34ecbbc82d848fa3997cc6fdb">configure</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *input, <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *output, <span class="keyword">const</span> int16_t *conv, <span class="keywordtype">bool</span> border_undefined);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a423f9a45a52983b4de5e2b347f4369c7">border_size</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a> _border_size; </div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;};</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ac72d613f7270604dbcad2553c278b16c">  106</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolution5x5HorKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolutionHorKernel&lt;5&gt;</a>;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#aab26624bf4b326f8145b2909a5042004">  108</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolution7x7HorKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolutionHorKernel&lt;7&gt;</a>;</div><div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a9f34ccad344bc43d25e8be2b828853aa">  110</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolution9x9HorKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">CLSeparableConvolutionHorKernel&lt;9&gt;</a>;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matrix_size&gt;</div><div class="line"><a name="l00114"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">  114</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolutionVertKernel</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml">ICLSimple2DKernel</a></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;{</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a07e35fa34ecbbc82d848fa3997cc6fdb">configure</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *input, <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *output, <span class="keyword">const</span> int16_t *conv, uint32_t scale, <span class="keywordtype">bool</span> border_undefined, <a class="code" href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">DataType</a> data_type = <a class="code" href="namespacearm__compute.xhtml#ab4e88c89b3b7ea1735996cc4def22d58aa1e28eee0339658d39a8b4d325b56e9c">DataType::S32</a>);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a423f9a45a52983b4de5e2b347f4369c7">border_size</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;};</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ac7295b0d8d71be75033238ad7fbba38c">  133</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolution5x5VertKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolutionVertKernel&lt;5&gt;</a>;</div><div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a0ffdf01e236016ce8d366a69875d1375">  135</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolution7x7VertKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolutionVertKernel&lt;7&gt;</a>;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a6d08e1e881bf611c1e1b9e2bb8810d19">  137</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolution9x9VertKernel</a> = <a class="code" href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">CLSeparableConvolutionVertKernel&lt;9&gt;</a>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="comment">/****************************************************************************************\</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment"> *                                 Rectangle Convolution                                *</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">\****************************************************************************************/</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">  147</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_c_l_kernel.xhtml">ICLKernel</a></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;{</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a>();</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;<a class="code" href="classarm__compute_1_1_i_c_l_simple_kernel.xhtml#a8bc8fdf1a67fbaaa3270fd5eeecfc6cf">operator=</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a>(<a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;<a class="code" href="classarm__compute_1_1_i_c_l_simple_kernel.xhtml#a8bc8fdf1a67fbaaa3270fd5eeecfc6cf">operator=</a>(<a class="code" href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">CLConvolutionRectangleKernel</a> &amp;&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a07e35fa34ecbbc82d848fa3997cc6fdb">configure</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *input, <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *output, <span class="keyword">const</span> int16_t *conv, uint32_t width, uint32_t height, uint32_t scale, <span class="keywordtype">bool</span> border_undefined);</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml#a493987e85723a8000eb26d1f00e2ad0e">run</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_window.xhtml">Window</a> &amp;<a class="code" href="classarm__compute_1_1_i_kernel.xhtml#a3f5646133956f06348b310ccc3d36353">window</a>, cl::CommandQueue &amp;queue) <span class="keyword">override</span>;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a> <a class="code" href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a423f9a45a52983b4de5e2b347f4369c7">border_size</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <a class="code" href="structarm__compute_1_1_border_size.xhtml">BorderSize</a>       _border_size;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a> *_input;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <a class="code" href="classarm__compute_1_1_i_c_l_tensor.xhtml">ICLTensor</a>       *_output;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;};</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;}</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/*__ARM_COMPUTE_CLCONVOLUTIONKERNEL_H__ */</span><span class="preprocessor"></span></div><div class="ttc" id="_i_c_l_simple2_d_kernel_8h_xhtml"><div class="ttname"><a href="_i_c_l_simple2_d_kernel_8h.xhtml">ICLSimple2DKernel.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_simple_kernel_xhtml_a8bc8fdf1a67fbaaa3270fd5eeecfc6cf"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_simple_kernel.xhtml#a8bc8fdf1a67fbaaa3270fd5eeecfc6cf">arm_compute::ICLSimpleKernel::operator=</a></div><div class="ttdeci">ICLSimpleKernel &amp; operator=(const ICLSimpleKernel &amp;)=delete</div><div class="ttdoc">Prevent instances of this class from being copied (As this class contains pointers). </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_separable_convolution_hor_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_separable_convolution_hor_kernel.xhtml">arm_compute::CLSeparableConvolutionHorKernel</a></div><div class="ttdoc">Kernel for the Horizontal pass of a Separable Convolution. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_convolution_kernel_8h_source.xhtml#l00084">CLConvolutionKernel.h:84</a></div></div>
<div class="ttc" id="structarm__compute_1_1_border_size_xhtml"><div class="ttname"><a href="structarm__compute_1_1_border_size.xhtml">arm_compute::BorderSize</a></div><div class="ttdoc">Container for 2D border size. </div><div class="ttdef"><b>Definition:</b> <a href="_types_8h_source.xhtml#l00116">Types.h:116</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_convolution_kernel_xhtml_a07e35fa34ecbbc82d848fa3997cc6fdb"><div class="ttname"><a href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a07e35fa34ecbbc82d848fa3997cc6fdb">arm_compute::CLConvolutionKernel::configure</a></div><div class="ttdeci">void configure(const ICLTensor *input, ICLTensor *output, const int16_t *conv, uint32_t scale, bool border_undefined)</div><div class="ttdoc">Initialise the kernel&amp;#39;s input, output and border mode. </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_convolution_kernel_xhtml_a423f9a45a52983b4de5e2b347f4369c7"><div class="ttname"><a href="classarm__compute_1_1_c_l_convolution_kernel.xhtml#a423f9a45a52983b4de5e2b347f4369c7">arm_compute::CLConvolutionKernel::border_size</a></div><div class="ttdeci">BorderSize border_size() const override</div><div class="ttdoc">The size of the border for that kernel. </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_convolution_rectangle_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_convolution_rectangle_kernel.xhtml">arm_compute::CLConvolutionRectangleKernel</a></div><div class="ttdoc">Kernel for the running convolution on a rectangle matrix. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_convolution_kernel_8h_source.xhtml#l00147">CLConvolutionKernel.h:147</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_kernel.xhtml">arm_compute::ICLKernel</a></div><div class="ttdoc">Common interface for all the OpenCL kernels. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_kernel_8h_source.xhtml#l00036">ICLKernel.h:36</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml"><div class="ttname"><a href="namespacearm__compute.xhtml">arm_compute</a></div><div class="ttdef"><b>Definition:</b> <a href="arm__compute_8dox_source.xhtml#l00001">arm_compute.dox:1</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml_ab4e88c89b3b7ea1735996cc4def22d58aa1e28eee0339658d39a8b4d325b56e9c"><div class="ttname"><a href="namespacearm__compute.xhtml#ab4e88c89b3b7ea1735996cc4def22d58aa1e28eee0339658d39a8b4d325b56e9c">arm_compute::Format::S32</a></div><div class="ttdoc">1 channel, 1 U16 per channel </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_convolution_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_convolution_kernel.xhtml">arm_compute::CLConvolutionKernel</a></div><div class="ttdoc">Interface for the kernel to run an arbitrary size convolution on a tensor. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_convolution_kernel_8h_source.xhtml#l00052">CLConvolutionKernel.h:52</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_simple2_d_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml">arm_compute::ICLSimple2DKernel</a></div><div class="ttdoc">Interface for simple OpenCL kernels having 1 tensor input and 1 tensor output. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_simple2_d_kernel_8h_source.xhtml#l00034">ICLSimple2DKernel.h:34</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_separable_convolution_vert_kernel_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_separable_convolution_vert_kernel.xhtml">arm_compute::CLSeparableConvolutionVertKernel</a></div><div class="ttdoc">Kernel for the Vertical pass of a Separable Convolution. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_convolution_kernel_8h_source.xhtml#l00114">CLConvolutionKernel.h:114</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml_af87af588094f04e537df98eaf0426cb6"><div class="ttname"><a href="namespacearm__compute.xhtml#af87af588094f04e537df98eaf0426cb6">arm_compute::ICLTensor</a></div><div class="ttdeci">ICLImage ICLTensor</div><div class="ttdef"><b>Definition:</b> <a href="_c_l_histogram_8h_source.xhtml#l00034">CLHistogram.h:34</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_tensor_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_tensor.xhtml">arm_compute::ICLTensor</a></div><div class="ttdoc">Interface for OpenCL tensor. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_tensor_8h_source.xhtml#l00040">ICLTensor.h:40</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_simple2_d_kernel_xhtml_a493987e85723a8000eb26d1f00e2ad0e"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_simple2_d_kernel.xhtml#a493987e85723a8000eb26d1f00e2ad0e">arm_compute::ICLSimple2DKernel::run</a></div><div class="ttdeci">void run(const Window &amp;window, cl::CommandQueue &amp;queue) override</div><div class="ttdoc">Enqueue the OpenCL kernel to process the given window on the passed OpenCL command queue...</div></div>
<div class="ttc" id="namespacearm__compute_xhtml_ad8ed01ff3ff33333d8e19db4d2818bb6"><div class="ttname"><a href="namespacearm__compute.xhtml#ad8ed01ff3ff33333d8e19db4d2818bb6">arm_compute::DataType</a></div><div class="ttdeci">DataType</div><div class="ttdoc">Available data types. </div><div class="ttdef"><b>Definition:</b> <a href="_types_8h_source.xhtml#l00059">Types.h:59</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_kernel_xhtml_a3f5646133956f06348b310ccc3d36353"><div class="ttname"><a href="classarm__compute_1_1_i_kernel.xhtml#a3f5646133956f06348b310ccc3d36353">arm_compute::IKernel::window</a></div><div class="ttdeci">const Window &amp; window() const </div><div class="ttdoc">The maximum window the kernel can be executed on. </div></div>
<div class="ttc" id="classarm__compute_1_1_window_xhtml"><div class="ttname"><a href="classarm__compute_1_1_window.xhtml">arm_compute::Window</a></div><div class="ttdoc">Describe a multidimensional execution window. </div><div class="ttdef"><b>Definition:</b> <a href="_window_8h_source.xhtml#l00039">Window.h:39</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_214608ef36d61442cb2b0c1c4e9a7def.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="dir_1fb090f0c6070330bfaccc4236d3ca0d.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_1633709b037eda5b8477677909f78129.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_f906bbebc596bc606d589ccb705e6595.xhtml">kernels</a></li><li class="navelem"><a class="el" href="_c_l_convolution_kernel_8h.xhtml">CLConvolutionKernel.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
